<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>QuorumPeer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">QuorumPeer.java</span></div><h1>QuorumPeer.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.zookeeper.server.quorum;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.zookeeper.common.AtomicFileOutputStream;
import org.apache.zookeeper.jmx.MBeanRegistry;
import org.apache.zookeeper.jmx.ZKMBeanInfo;
import org.apache.zookeeper.server.ServerCnxnFactory;
import org.apache.zookeeper.server.ZKDatabase;
import org.apache.zookeeper.server.ZooKeeperServer;
import org.apache.zookeeper.server.ZooKeeperThread;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog;
import org.apache.zookeeper.server.quorum.flexible.QuorumMaj;
import org.apache.zookeeper.server.quorum.flexible.QuorumVerifier;
import org.apache.zookeeper.server.util.ZxidUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This class manages the quorum protocol. There are three states this server
 * can be in:
 * &lt;ol&gt;
 * &lt;li&gt;Leader election - each server will elect a leader (proposing itself as a
 * leader initially).&lt;/li&gt;
 * &lt;li&gt;Follower - the server will synchronize with the leader and replicate any
 * transactions.&lt;/li&gt;
 * &lt;li&gt;Leader - the server will process requests and forward them to followers.
 * A majority of followers must log the request before it can be accepted.
 * &lt;/ol&gt;
 *
 * This class will setup a datagram socket that will always respond with its
 * view of the current leader. The response will take the form of:
 *
 * &lt;pre&gt;
 * int xid;
 *
 * long myid;
 *
 * long leader_id;
 *
 * long leader_zxid;
 * &lt;/pre&gt;
 *
 * The request for the current leader will consist solely of an xid: int xid;
 */
<span class="pc bpc" id="L81" title="1 of 2 branches missed.">public class QuorumPeer extends ZooKeeperThread implements QuorumStats.Provider {</span>
<span class="fc" id="L82">    private static final Logger LOG = LoggerFactory.getLogger(QuorumPeer.class);</span>

    QuorumBean jmxQuorumBean;
    LocalPeerBean jmxLocalPeerBean;
    LeaderElectionBean jmxLeaderElectionBean;
    QuorumCnxManager qcm;

    /* ZKDatabase is a top level member of quorumpeer 
     * which will be used in all the zookeeperservers
     * instantiated later. Also, it is created once on 
     * bootup and only thrown away in case of a truncate
     * message from the leader
     */
    private ZKDatabase zkDb;

    public static class QuorumServer {
        private QuorumServer(long id, InetSocketAddress addr,
<span class="nc" id="L99">                InetSocketAddress electionAddr) {</span>
<span class="nc" id="L100">            this.id = id;</span>
<span class="nc" id="L101">            this.addr = addr;</span>
<span class="nc" id="L102">            this.electionAddr = electionAddr;</span>
<span class="nc" id="L103">        }</span>

<span class="nc" id="L105">        private QuorumServer(long id, InetSocketAddress addr) {</span>
<span class="nc" id="L106">            this.id = id;</span>
<span class="nc" id="L107">            this.addr = addr;</span>
<span class="nc" id="L108">            this.electionAddr = null;</span>
<span class="nc" id="L109">        }</span>
        
        private QuorumServer(long id, InetSocketAddress addr,
<span class="nc" id="L112">                    InetSocketAddress electionAddr, LearnerType type) {</span>
<span class="nc" id="L113">            this.id = id;</span>
<span class="nc" id="L114">            this.addr = addr;</span>
<span class="nc" id="L115">            this.electionAddr = electionAddr;</span>
<span class="nc" id="L116">            this.type = type;</span>
<span class="nc" id="L117">        }</span>
        
        public QuorumServer(long id, String hostname,
                            Integer port, Integer electionPort,
<span class="fc" id="L121">                            LearnerType type) {</span>
<span class="fc" id="L122">	        this.id = id;</span>
<span class="fc" id="L123">	        this.hostname=hostname;</span>
<span class="pc bpc" id="L124" title="1 of 2 branches missed.">	        if (port!=null){</span>
<span class="fc" id="L125">                this.port=port;</span>
	        }
<span class="pc bpc" id="L127" title="1 of 2 branches missed.">	        if (electionPort!=null){</span>
<span class="fc" id="L128">                this.electionPort=electionPort;</span>
	        }
<span class="fc bfc" id="L130" title="All 2 branches covered.">	        if (type!=null){</span>
<span class="fc" id="L131">                this.type = type;</span>
	        }
<span class="fc" id="L133">	        this.recreateSocketAddresses();</span>
<span class="fc" id="L134">	    }</span>

        /**
         * Performs a DNS lookup of hostname and (re)creates the this.addr and
         * this.electionAddr InetSocketAddress objects as appropriate
         *
         * If the DNS lookup fails, this.addr and electionAddr remain
         * unmodified, unless they were never set. If this.addr is null, then
         * it is set with an unresolved InetSocketAddress object. this.electionAddr
         * is handled similarly.
         */
        public void recreateSocketAddresses() {
<span class="fc" id="L146">            InetAddress address = null;</span>
            try {
<span class="fc" id="L148">                address = InetAddress.getByName(this.hostname);</span>
<span class="fc" id="L149">                LOG.info(&quot;Resolved hostname: {} to address: {}&quot;, this.hostname, address);</span>
<span class="fc" id="L150">                this.addr = new InetSocketAddress(address, this.port);</span>
<span class="fc bfc" id="L151" title="All 2 branches covered.">                if (this.electionPort &gt; 0){</span>
<span class="fc" id="L152">                    this.electionAddr = new InetSocketAddress(address, this.electionPort);</span>
                }
<span class="fc" id="L154">            } catch (UnknownHostException ex) {</span>
<span class="fc" id="L155">                LOG.warn(&quot;Failed to resolve address: {}&quot;, this.hostname, ex);</span>
                // Have we succeeded in the past?
<span class="fc bfc" id="L157" title="All 2 branches covered.">                if (this.addr != null) {</span>
                    // Yes, previously the lookup succeeded. Leave things as they are
<span class="fc" id="L159">                    return;</span>
                }
                // The hostname has never resolved. Create our InetSocketAddress(es) as unresolved
<span class="fc" id="L162">                this.addr = InetSocketAddress.createUnresolved(this.hostname, this.port);</span>
<span class="pc bpc" id="L163" title="1 of 2 branches missed.">                if (this.electionPort &gt; 0){</span>
<span class="fc" id="L164">                    this.electionAddr = InetSocketAddress.createUnresolved(this.hostname,</span>
                                                                           this.electionPort);
                }
<span class="fc" id="L167">            }</span>
<span class="fc" id="L168">        }</span>

        public InetSocketAddress addr;

        public InetSocketAddress electionAddr;
        
        public String hostname;

<span class="pc" id="L176">        public int port=2888;</span>

<span class="pc" id="L178">        public int electionPort=-1;</span>

        public long id;
        
<span class="pc" id="L182">        public LearnerType type = LearnerType.PARTICIPANT;</span>
    }

<span class="pc" id="L185">    public enum ServerState {</span>
<span class="fc" id="L186">        LOOKING, FOLLOWING, LEADING, OBSERVING;</span>
    }
    
    /*
     * A peer can either be participating, which implies that it is willing to
     * both vote in instances of consensus and to elect or become a Leader, or
     * it may be observing in which case it isn't.
     * 
     * We need this distinction to decide which ServerState to move to when 
     * conditions change (e.g. which state to become after LOOKING). 
     */
<span class="pc" id="L197">    public enum LearnerType {</span>
<span class="fc" id="L198">        PARTICIPANT, OBSERVER;</span>
    }
    
    /*
     * To enable observers to have no identifier, we need a generic identifier
     * at least for QuorumCnxManager. We use the following constant to as the
     * value of such a generic identifier. 
     */
    
    static final long OBSERVER_ID = Long.MAX_VALUE;

    /*
     * Record leader election time
     */
    public long start_fle, end_fle;
    
    /*
     * Default value of peer is participant
     */
<span class="fc" id="L217">    private LearnerType learnerType = LearnerType.PARTICIPANT;</span>
    
    public LearnerType getLearnerType() {
<span class="fc" id="L220">        return learnerType;</span>
    }
    
    /**
     * Sets the LearnerType both in the QuorumPeer and in the peerMap
     */
    public void setLearnerType(LearnerType p) {
<span class="fc" id="L227">        learnerType = p;</span>
<span class="pc bpc" id="L228" title="1 of 2 branches missed.">        if (quorumPeers.containsKey(this.myid)) {</span>
<span class="fc" id="L229">            this.quorumPeers.get(myid).type = p;</span>
        } else {
<span class="nc" id="L231">            LOG.error(&quot;Setting LearnerType to &quot; + p + &quot; but &quot; + myid </span>
                    + &quot; not in QuorumPeers. &quot;);
        }
        
<span class="fc" id="L235">    }</span>
    /**
     * The servers that make up the cluster
     */
    protected Map&lt;Long, QuorumServer&gt; quorumPeers;
    public int getQuorumSize(){
<span class="fc" id="L241">        return getVotingView().size();</span>
    }
    
    /**
     * QuorumVerifier implementation; default (majority). 
     */
    
    private QuorumVerifier quorumConfig;
    
    /**
     * My id
     */
    private long myid;


    /**
     * get the id of this quorum peer.
     */
    public long getId() {
<span class="fc" id="L260">        return myid;</span>
    }

    /**
     * This is who I think the leader currently is.
     */
    volatile private Vote currentVote;
    
    /**
     * ... and its counterpart for backward compatibility
     */
    volatile private Vote bcVote;
        
    public synchronized Vote getCurrentVote(){
<span class="fc" id="L274">        return currentVote;</span>
    }
       
    public synchronized void setCurrentVote(Vote v){
<span class="fc" id="L278">        currentVote = v;</span>
<span class="fc" id="L279">    }</span>
    
    synchronized Vote getBCVote() {
<span class="nc bnc" id="L282" title="All 2 branches missed.">        if (bcVote == null) {</span>
<span class="nc" id="L283">            return currentVote;</span>
        } else {
<span class="nc" id="L285">            return bcVote;</span>
        }
    }

    synchronized void setBCVote(Vote v) {
<span class="fc" id="L290">        bcVote = v;</span>
<span class="fc" id="L291">    }</span>
    
<span class="fc" id="L293">    volatile boolean running = true;</span>

    /**
     * The number of milliseconds of each tick
     */
    protected int tickTime;

    /**
     * Minimum number of milliseconds to allow for session timeout.
     * A value of -1 indicates unset, use default.
     */
<span class="fc" id="L304">    protected int minSessionTimeout = -1;</span>

    /**
     * Maximum number of milliseconds to allow for session timeout.
     * A value of -1 indicates unset, use default.
     */
<span class="fc" id="L310">    protected int maxSessionTimeout = -1;</span>

    /**
     * The number of ticks that the initial synchronization phase can take
     */
    protected int initLimit;

    /**
     * The number of ticks that can pass between sending a request and getting
     * an acknowledgment
     */
    protected int syncLimit;
    
    /**
     * Enables/Disables sync request processor. This option is enabled
     * by default and is to be used with observers.
     */
<span class="fc" id="L327">    protected boolean syncEnabled = true;</span>

    /**
     * The current tick
     */
    protected volatile int tick;

    /**
     * Whether or not to listen on all IPs for the two quorum ports
     * (broadcast and fast leader election).
     */
<span class="fc" id="L338">    protected boolean quorumListenOnAllIPs = false;</span>

    /**
     * @deprecated As of release 3.4.0, this class has been deprecated, since
     * it is used with one of the udp-based versions of leader election, which
     * we are also deprecating. 
     * 
     * This class simply responds to requests for the current leader of this
     * node.
     * &lt;p&gt;
     * The request contains just an xid generated by the requestor.
     * &lt;p&gt;
     * The response has the xid, the id of this server, the id of the leader,
     * and the zxid of the leader.
     *
     *
     */
    @Deprecated
    class ResponderThread extends ZooKeeperThread {
<span class="fc" id="L357">        ResponderThread() {</span>
<span class="fc" id="L358">            super(&quot;ResponderThread&quot;);</span>
<span class="fc" id="L359">        }</span>

<span class="fc" id="L361">        volatile boolean running = true;</span>
        
        @Override
        public void run() {
            try {
<span class="fc" id="L366">                byte b[] = new byte[36];</span>
<span class="fc" id="L367">                ByteBuffer responseBuffer = ByteBuffer.wrap(b);</span>
<span class="fc" id="L368">                DatagramPacket packet = new DatagramPacket(b, b.length);</span>
<span class="fc bfc" id="L369" title="All 2 branches covered.">                while (running) {</span>
<span class="fc" id="L370">                    udpSocket.receive(packet);</span>
<span class="pc bpc" id="L371" title="1 of 2 branches missed.">                    if (packet.getLength() != 4) {</span>
<span class="nc" id="L372">                        LOG.warn(&quot;Got more than just an xid! Len = &quot;</span>
<span class="nc" id="L373">                                + packet.getLength());</span>
                    } else {
<span class="fc" id="L375">                        responseBuffer.clear();</span>
<span class="fc" id="L376">                        responseBuffer.getInt(); // Skip the xid</span>
<span class="fc" id="L377">                        responseBuffer.putLong(myid);</span>
<span class="fc" id="L378">                        Vote current = getCurrentVote();</span>
<span class="pc bpc" id="L379" title="1 of 4 branches missed.">                        switch (getPeerState()) {</span>
                        case LOOKING:
<span class="fc" id="L381">                            responseBuffer.putLong(current.getId());</span>
<span class="fc" id="L382">                            responseBuffer.putLong(current.getZxid());</span>
<span class="fc" id="L383">                            break;</span>
                        case LEADING:
<span class="fc" id="L385">                            responseBuffer.putLong(myid);</span>
                            try {
                                long proposed;
<span class="fc" id="L388">                                synchronized(leader) {</span>
<span class="fc" id="L389">                                    proposed = leader.lastProposed;</span>
<span class="pc" id="L390">                                }</span>
<span class="fc" id="L391">                                responseBuffer.putLong(proposed);</span>
<span class="fc" id="L392">                            } catch (NullPointerException npe) {</span>
                                // This can happen in state transitions,
                                // just ignore the request
<span class="fc" id="L395">                            }</span>
<span class="fc" id="L396">                            break;</span>
                        case FOLLOWING:
<span class="fc" id="L398">                            responseBuffer.putLong(current.getId());</span>
                            try {
<span class="fc" id="L400">                                responseBuffer.putLong(follower.getZxid());</span>
<span class="fc" id="L401">                            } catch (NullPointerException npe) {</span>
                                // This can happen in state transitions,
                                // just ignore the request
<span class="fc" id="L404">                            }</span>
<span class="fc" id="L405">                            break;</span>
                        case OBSERVING:
                            // Do nothing, Observers keep themselves to
                            // themselves. 
                            break;
                        }
<span class="fc" id="L411">                        packet.setData(b);</span>
<span class="fc" id="L412">                        udpSocket.send(packet);</span>
                    }
<span class="fc" id="L414">                    packet.setLength(b.length);</span>
                }
<span class="pc" id="L416">            } catch (RuntimeException e) {</span>
<span class="nc" id="L417">                LOG.warn(&quot;Unexpected runtime exception in ResponderThread&quot;,e);</span>
<span class="pc" id="L418">            } catch (IOException e) {</span>
<span class="fc" id="L419">                LOG.warn(&quot;Unexpected IO exception in ResponderThread&quot;,e);</span>
<span class="fc" id="L420">            } finally {</span>
<span class="nc" id="L421">                LOG.warn(&quot;QuorumPeer responder thread exited&quot;);</span>
<span class="pc" id="L422">            }</span>
<span class="pc" id="L423">        }</span>
    }

<span class="fc" id="L426">    private ServerState state = ServerState.LOOKING;</span>

    public synchronized void setPeerState(ServerState newState){
<span class="fc" id="L429">        state=newState;</span>
<span class="fc" id="L430">    }</span>

    public synchronized ServerState getPeerState(){
<span class="fc" id="L433">        return state;</span>
    }

    DatagramSocket udpSocket;

    private InetSocketAddress myQuorumAddr;

    public InetSocketAddress getQuorumAddress(){
<span class="fc" id="L441">        return myQuorumAddr;</span>
    }

    private int electionType;

    Election electionAlg;

    ServerCnxnFactory cnxnFactory;
<span class="fc" id="L449">    private FileTxnSnapLog logFactory = null;</span>

    private final QuorumStats quorumStats;
    
    public QuorumPeer() {
<span class="fc" id="L454">        super(&quot;QuorumPeer&quot;);</span>
<span class="fc" id="L455">        quorumStats = new QuorumStats(this);</span>
<span class="fc" id="L456">    }</span>
    
   
    /**
     * For backward compatibility purposes, we instantiate QuorumMaj by default.
     */
    
    public QuorumPeer(Map&lt;Long, QuorumServer&gt; quorumPeers, File dataDir,
            File dataLogDir, int electionType,
            long myid, int tickTime, int initLimit, int syncLimit,
            ServerCnxnFactory cnxnFactory) throws IOException {
<span class="nc" id="L467">        this(quorumPeers, dataDir, dataLogDir, electionType, myid, tickTime, </span>
        		initLimit, syncLimit, false, cnxnFactory, 
<span class="nc" id="L469">        		new QuorumMaj(countParticipants(quorumPeers)));</span>
<span class="nc" id="L470">    }</span>
    
    public QuorumPeer(Map&lt;Long, QuorumServer&gt; quorumPeers, File dataDir,
            File dataLogDir, int electionType,
            long myid, int tickTime, int initLimit, int syncLimit,
            boolean quorumListenOnAllIPs,
            ServerCnxnFactory cnxnFactory, 
            QuorumVerifier quorumConfig) throws IOException {
<span class="fc" id="L478">        this();</span>
<span class="fc" id="L479">        this.cnxnFactory = cnxnFactory;</span>
<span class="fc" id="L480">        this.quorumPeers = quorumPeers;</span>
<span class="fc" id="L481">        this.electionType = electionType;</span>
<span class="fc" id="L482">        this.myid = myid;</span>
<span class="fc" id="L483">        this.tickTime = tickTime;</span>
<span class="fc" id="L484">        this.initLimit = initLimit;</span>
<span class="fc" id="L485">        this.syncLimit = syncLimit;        </span>
<span class="fc" id="L486">        this.quorumListenOnAllIPs = quorumListenOnAllIPs;</span>
<span class="fc" id="L487">        this.logFactory = new FileTxnSnapLog(dataLogDir, dataDir);</span>
<span class="fc" id="L488">        this.zkDb = new ZKDatabase(this.logFactory);</span>
<span class="pc bpc" id="L489" title="1 of 2 branches missed.">        if(quorumConfig == null)</span>
<span class="nc" id="L490">            this.quorumConfig = new QuorumMaj(countParticipants(quorumPeers));</span>
<span class="fc" id="L491">        else this.quorumConfig = quorumConfig;</span>
<span class="fc" id="L492">    }</span>
    
    QuorumStats quorumStats() {
<span class="nc" id="L495">        return quorumStats;</span>
    }
    
    @Override
    public synchronized void start() {
<span class="fc" id="L500">        loadDataBase();</span>
<span class="fc" id="L501">        cnxnFactory.start();        </span>
<span class="fc" id="L502">        startLeaderElection();</span>
<span class="fc" id="L503">        super.start();</span>
<span class="fc" id="L504">    }</span>

    private void loadDataBase() {
<span class="fc" id="L507">        File updating = new File(getTxnFactory().getSnapDir(),</span>
                                 UPDATING_EPOCH_FILENAME);
		try {
<span class="fc" id="L510">            zkDb.loadDataBase();</span>

            // load the epochs
<span class="fc" id="L513">            long lastProcessedZxid = zkDb.getDataTree().lastProcessedZxid;</span>
<span class="fc" id="L514">    		long epochOfZxid = ZxidUtils.getEpochFromZxid(lastProcessedZxid);</span>
            try {
<span class="fc" id="L516">            	currentEpoch = readLongFromFile(CURRENT_EPOCH_FILENAME);</span>
<span class="fc bfc" id="L517" title="All 4 branches covered.">                if (epochOfZxid &gt; currentEpoch &amp;&amp; updating.exists()) {</span>
<span class="fc" id="L518">                    LOG.info(&quot;{} found. The server was terminated after &quot; +</span>
                             &quot;taking a snapshot but before updating current &quot; +
                             &quot;epoch. Setting current epoch to {}.&quot;,
<span class="fc" id="L521">                             UPDATING_EPOCH_FILENAME, epochOfZxid);</span>
<span class="fc" id="L522">                    setCurrentEpoch(epochOfZxid);</span>
<span class="pc bpc" id="L523" title="1 of 2 branches missed.">                    if (!updating.delete()) {</span>
<span class="nc" id="L524">                        throw new IOException(&quot;Failed to delete &quot; +</span>
<span class="nc" id="L525">                                              updating.toString());</span>
                    }
                }
<span class="fc" id="L528">            } catch(FileNotFoundException e) {</span>
            	// pick a reasonable epoch number
            	// this should only happen once when moving to a
            	// new code version
<span class="fc" id="L532">            	currentEpoch = epochOfZxid;</span>
<span class="fc" id="L533">            	LOG.info(CURRENT_EPOCH_FILENAME</span>
            	        + &quot; not found! Creating with a reasonable default of {}. This should only happen when you are upgrading your installation&quot;,
<span class="fc" id="L535">            	        currentEpoch);</span>
<span class="fc" id="L536">            	writeLongToFile(CURRENT_EPOCH_FILENAME, currentEpoch);</span>
<span class="fc" id="L537">            }</span>
<span class="fc bfc" id="L538" title="All 2 branches covered.">            if (epochOfZxid &gt; currentEpoch) {</span>
<span class="fc" id="L539">            	throw new IOException(&quot;The current epoch, &quot; + ZxidUtils.zxidToString(currentEpoch) + &quot;, is older than the last zxid, &quot; + lastProcessedZxid);</span>
            }
            try {
<span class="fc" id="L542">            	acceptedEpoch = readLongFromFile(ACCEPTED_EPOCH_FILENAME);</span>
<span class="fc" id="L543">            } catch(FileNotFoundException e) {</span>
            	// pick a reasonable epoch number
            	// this should only happen once when moving to a
            	// new code version
<span class="fc" id="L547">            	acceptedEpoch = epochOfZxid;</span>
<span class="fc" id="L548">            	LOG.info(ACCEPTED_EPOCH_FILENAME</span>
            	        + &quot; not found! Creating with a reasonable default of {}. This should only happen when you are upgrading your installation&quot;,
<span class="fc" id="L550">            	        acceptedEpoch);</span>
<span class="fc" id="L551">            	writeLongToFile(ACCEPTED_EPOCH_FILENAME, acceptedEpoch);</span>
<span class="fc" id="L552">            }</span>
<span class="pc bpc" id="L553" title="1 of 2 branches missed.">            if (acceptedEpoch &lt; currentEpoch) {</span>
<span class="nc" id="L554">            	throw new IOException(&quot;The accepted epoch, &quot; + ZxidUtils.zxidToString(acceptedEpoch) + &quot; is less than the current epoch, &quot; + ZxidUtils.zxidToString(currentEpoch));</span>
            }
<span class="fc" id="L556">        } catch(IOException ie) {</span>
<span class="fc" id="L557">            LOG.error(&quot;Unable to load database on disk&quot;, ie);</span>
<span class="fc" id="L558">            throw new RuntimeException(&quot;Unable to run quorum server &quot;, ie);</span>
<span class="fc" id="L559">        }</span>
<span class="fc" id="L560">	}</span>

    ResponderThread responder;
    
    synchronized public void stopLeaderElection() {
<span class="fc" id="L565">        responder.running = false;</span>
<span class="fc" id="L566">        responder.interrupt();</span>
<span class="fc" id="L567">    }</span>
    synchronized public void startLeaderElection() {
    	try {
<span class="fc" id="L570">    		currentVote = new Vote(myid, getLastLoggedZxid(), getCurrentEpoch());</span>
<span class="nc" id="L571">    	} catch(IOException e) {</span>
<span class="nc" id="L572">    		RuntimeException re = new RuntimeException(e.getMessage());</span>
<span class="nc" id="L573">    		re.setStackTrace(e.getStackTrace());</span>
<span class="nc" id="L574">    		throw re;</span>
<span class="fc" id="L575">    	}</span>
<span class="pc bpc" id="L576" title="1 of 2 branches missed.">        for (QuorumServer p : getView().values()) {</span>
<span class="fc bfc" id="L577" title="All 2 branches covered.">            if (p.id == myid) {</span>
<span class="fc" id="L578">                myQuorumAddr = p.addr;</span>
<span class="fc" id="L579">                break;</span>
            }
<span class="fc" id="L581">        }</span>
<span class="pc bpc" id="L582" title="1 of 2 branches missed.">        if (myQuorumAddr == null) {</span>
<span class="nc" id="L583">            throw new RuntimeException(&quot;My id &quot; + myid + &quot; not in the peer list&quot;);</span>
        }
<span class="fc bfc" id="L585" title="All 2 branches covered.">        if (electionType == 0) {</span>
            try {
<span class="fc" id="L587">                udpSocket = new DatagramSocket(myQuorumAddr.getPort());</span>
<span class="fc" id="L588">                responder = new ResponderThread();</span>
<span class="fc" id="L589">                responder.start();</span>
<span class="nc" id="L590">            } catch (SocketException e) {</span>
<span class="nc" id="L591">                throw new RuntimeException(e);</span>
<span class="fc" id="L592">            }</span>
        }
<span class="fc" id="L594">        this.electionAlg = createElectionAlgorithm(electionType);</span>
<span class="fc" id="L595">    }</span>
    
    /**
     * Count the number of nodes in the map that could be followers.
     * @param peers
     * @return The number of followers in the map
     */
    protected static int countParticipants(Map&lt;Long,QuorumServer&gt; peers) {
<span class="fc" id="L603">      int count = 0;</span>
<span class="fc bfc" id="L604" title="All 2 branches covered.">      for (QuorumServer q : peers.values()) {</span>
<span class="fc bfc" id="L605" title="All 2 branches covered.">          if (q.type == LearnerType.PARTICIPANT) {</span>
<span class="fc" id="L606">              count++;</span>
          }
<span class="fc" id="L608">      }</span>
<span class="fc" id="L609">      return count;</span>
    }
    
    /**
     * This constructor is only used by the existing unit test code.
     * It defaults to FileLogProvider persistence provider.
     */
    public QuorumPeer(Map&lt;Long,QuorumServer&gt; quorumPeers, File snapDir,
            File logDir, int clientPort, int electionAlg,
            long myid, int tickTime, int initLimit, int syncLimit)
        throws IOException
    {
<span class="fc" id="L621">        this(quorumPeers, snapDir, logDir, electionAlg,</span>
                myid,tickTime, initLimit,syncLimit, false,
<span class="fc" id="L623">                ServerCnxnFactory.createFactory(new InetSocketAddress(clientPort), -1),</span>
<span class="fc" id="L624">                new QuorumMaj(countParticipants(quorumPeers)));</span>
<span class="fc" id="L625">    }</span>
    
    /**
     * This constructor is only used by the existing unit test code.
     * It defaults to FileLogProvider persistence provider.
     */
    public QuorumPeer(Map&lt;Long,QuorumServer&gt; quorumPeers, File snapDir,
            File logDir, int clientPort, int electionAlg,
            long myid, int tickTime, int initLimit, int syncLimit, 
            QuorumVerifier quorumConfig)
        throws IOException
    {
<span class="fc" id="L637">        this(quorumPeers, snapDir, logDir, electionAlg,</span>
                myid,tickTime, initLimit,syncLimit, false,
<span class="fc" id="L639">                ServerCnxnFactory.createFactory(new InetSocketAddress(clientPort), -1),</span>
                quorumConfig);
<span class="fc" id="L641">    }</span>
    
    /**
     * returns the highest zxid that this host has seen
     * 
     * @return the highest zxid for this host
     */
    public long getLastLoggedZxid() {
<span class="fc bfc" id="L649" title="All 2 branches covered.">        if (!zkDb.isInitialized()) {</span>
<span class="fc" id="L650">        	loadDataBase();</span>
        }
<span class="fc" id="L652">        return zkDb.getDataTreeLastProcessedZxid();</span>
    }
    
    public Follower follower;
    public Leader leader;
    public Observer observer;

    protected Follower makeFollower(FileTxnSnapLog logFactory) throws IOException {
<span class="fc" id="L660">        return new Follower(this, new FollowerZooKeeperServer(logFactory, </span>
                this,new ZooKeeperServer.BasicDataTreeBuilder(), this.zkDb));
    }
     
    protected Leader makeLeader(FileTxnSnapLog logFactory) throws IOException {
<span class="fc" id="L665">        return new Leader(this, new LeaderZooKeeperServer(logFactory,</span>
                this,new ZooKeeperServer.BasicDataTreeBuilder(), this.zkDb));
    }
    
    protected Observer makeObserver(FileTxnSnapLog logFactory) throws IOException {
<span class="fc" id="L670">        return new Observer(this, new ObserverZooKeeperServer(logFactory,</span>
                this, new ZooKeeperServer.BasicDataTreeBuilder(), this.zkDb));
    }

    protected Election createElectionAlgorithm(int electionAlgorithm){
<span class="fc" id="L675">        Election le=null;</span>
                
        //TODO: use a factory rather than a switch
<span class="pc bpc" id="L678" title="3 of 5 branches missed.">        switch (electionAlgorithm) {</span>
        case 0:
<span class="fc" id="L680">            le = new LeaderElection(this);</span>
<span class="fc" id="L681">            break;</span>
        case 1:
<span class="nc" id="L683">            le = new AuthFastLeaderElection(this);</span>
<span class="nc" id="L684">            break;</span>
        case 2:
<span class="nc" id="L686">            le = new AuthFastLeaderElection(this, true);</span>
<span class="nc" id="L687">            break;</span>
        case 3:
<span class="fc" id="L689">            qcm = new QuorumCnxManager(this);</span>
<span class="fc" id="L690">            QuorumCnxManager.Listener listener = qcm.listener;</span>
<span class="pc bpc" id="L691" title="1 of 2 branches missed.">            if(listener != null){</span>
<span class="fc" id="L692">                listener.start();</span>
<span class="fc" id="L693">                le = new FastLeaderElection(this, qcm);</span>
            } else {
<span class="nc" id="L695">                LOG.error(&quot;Null listener when initializing cnx manager&quot;);</span>
            }
<span class="nc" id="L697">            break;</span>
        default:
<span class="nc bnc" id="L699" title="All 2 branches missed.">            assert false;</span>
        }
<span class="fc" id="L701">        return le;</span>
    }

    protected Election makeLEStrategy(){
<span class="fc" id="L705">        LOG.debug(&quot;Initializing leader election protocol...&quot;);</span>
<span class="fc bfc" id="L706" title="All 2 branches covered.">        if (getElectionType() == 0) {</span>
<span class="fc" id="L707">            electionAlg = new LeaderElection(this);</span>
        }        
<span class="fc" id="L709">        return electionAlg;</span>
    }

    synchronized protected void setLeader(Leader newLeader){
<span class="fc" id="L713">        leader=newLeader;</span>
<span class="fc" id="L714">    }</span>

    synchronized protected void setFollower(Follower newFollower){
<span class="fc" id="L717">        follower=newFollower;</span>
<span class="fc" id="L718">    }</span>
    
    synchronized protected void setObserver(Observer newObserver){
<span class="fc" id="L721">        observer=newObserver;</span>
<span class="fc" id="L722">    }</span>

    synchronized public ZooKeeperServer getActiveServer(){
<span class="fc bfc" id="L725" title="All 2 branches covered.">        if(leader!=null)</span>
<span class="fc" id="L726">            return leader.zk;</span>
<span class="pc bpc" id="L727" title="1 of 2 branches missed.">        else if(follower!=null)</span>
<span class="fc" id="L728">            return follower.zk;</span>
<span class="nc bnc" id="L729" title="All 2 branches missed.">        else if (observer != null)</span>
<span class="nc" id="L730">            return observer.zk;</span>
<span class="nc" id="L731">        return null;</span>
    }

    @Override
    public void run() {
<span class="fc" id="L736">        setName(&quot;QuorumPeer&quot; + &quot;[myid=&quot; + getId() + &quot;]&quot; +</span>
<span class="fc" id="L737">                cnxnFactory.getLocalAddress());</span>

<span class="fc" id="L739">        LOG.debug(&quot;Starting quorum peer&quot;);</span>
        try {
<span class="fc" id="L741">            jmxQuorumBean = new QuorumBean(this);</span>
<span class="fc" id="L742">            MBeanRegistry.getInstance().register(jmxQuorumBean, null);</span>
<span class="fc bfc" id="L743" title="All 2 branches covered.">            for(QuorumServer s: getView().values()){</span>
                ZKMBeanInfo p;
<span class="fc bfc" id="L745" title="All 2 branches covered.">                if (getId() == s.id) {</span>
<span class="fc" id="L746">                    p = jmxLocalPeerBean = new LocalPeerBean(this);</span>
                    try {
<span class="fc" id="L748">                        MBeanRegistry.getInstance().register(p, jmxQuorumBean);</span>
<span class="nc" id="L749">                    } catch (Exception e) {</span>
<span class="nc" id="L750">                        LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="nc" id="L751">                        jmxLocalPeerBean = null;</span>
<span class="pc" id="L752">                    }</span>
                } else {
<span class="fc" id="L754">                    p = new RemotePeerBean(s);</span>
                    try {
<span class="fc" id="L756">                        MBeanRegistry.getInstance().register(p, jmxQuorumBean);</span>
<span class="nc" id="L757">                    } catch (Exception e) {</span>
<span class="nc" id="L758">                        LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="fc" id="L759">                    }</span>
                }
<span class="fc" id="L761">            }</span>
<span class="fc" id="L762">        } catch (Exception e) {</span>
<span class="fc" id="L763">            LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="fc" id="L764">            jmxQuorumBean = null;</span>
<span class="fc" id="L765">        }</span>

        try {
            /*
             * Main loop
             */
<span class="fc bfc" id="L771" title="All 2 branches covered.">            while (running) {</span>
<span class="pc bpc" id="L772" title="1 of 5 branches missed.">                switch (getPeerState()) {</span>
                case LOOKING:
<span class="fc" id="L774">                    LOG.info(&quot;LOOKING&quot;);</span>

<span class="fc bfc" id="L776" title="All 2 branches covered.">                    if (Boolean.getBoolean(&quot;readonlymode.enabled&quot;)) {</span>
<span class="fc" id="L777">                        LOG.info(&quot;Attempting to start ReadOnlyZooKeeperServer&quot;);</span>

                        // Create read-only server but don't start it immediately
<span class="fc" id="L780">                        final ReadOnlyZooKeeperServer roZk = new ReadOnlyZooKeeperServer(</span>
                                logFactory, this,
                                new ZooKeeperServer.BasicDataTreeBuilder(),
                                this.zkDb);
    
                        // Instead of starting roZk immediately, wait some grace
                        // period before we decide we're partitioned.
                        //
                        // Thread is used here because otherwise it would require
                        // changes in each of election strategy classes which is
                        // unnecessary code coupling.
<span class="fc" id="L791">                        Thread roZkMgr = new Thread() {</span>
                            public void run() {
                                try {
                                    // lower-bound grace period to 2 secs
<span class="fc" id="L795">                                    sleep(Math.max(2000, tickTime));</span>
<span class="pc bpc" id="L796" title="1 of 2 branches missed.">                                    if (ServerState.LOOKING.equals(getPeerState())) {</span>
<span class="fc" id="L797">                                        roZk.startup();</span>
                                    }
<span class="fc" id="L799">                                } catch (InterruptedException e) {</span>
<span class="fc" id="L800">                                    LOG.info(&quot;Interrupted while attempting to start ReadOnlyZooKeeperServer, not started&quot;);</span>
<span class="nc" id="L801">                                } catch (Exception e) {</span>
<span class="nc" id="L802">                                    LOG.error(&quot;FAILED to start ReadOnlyZooKeeperServer&quot;, e);</span>
<span class="fc" id="L803">                                }</span>
<span class="fc" id="L804">                            }</span>
                        };
                        try {
<span class="fc" id="L807">                            roZkMgr.start();</span>
<span class="fc" id="L808">                            setBCVote(null);</span>
<span class="fc" id="L809">                            setCurrentVote(makeLEStrategy().lookForLeader());</span>
<span class="fc" id="L810">                        } catch (Exception e) {</span>
<span class="fc" id="L811">                            LOG.warn(&quot;Unexpected exception&quot;,e);</span>
<span class="fc" id="L812">                            setPeerState(ServerState.LOOKING);</span>
<span class="fc" id="L813">                        } finally {</span>
                            // If the thread is in the the grace period, interrupt
                            // to come out of waiting.
<span class="nc" id="L816">                            roZkMgr.interrupt();</span>
<span class="pc" id="L817">                            roZk.shutdown();</span>
<span class="fc" id="L818">                        }</span>
<span class="fc" id="L819">                    } else {</span>
                        try {
<span class="fc" id="L821">                            setBCVote(null);</span>
<span class="fc" id="L822">                            setCurrentVote(makeLEStrategy().lookForLeader());</span>
<span class="fc" id="L823">                        } catch (Exception e) {</span>
<span class="fc" id="L824">                            LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="fc" id="L825">                            setPeerState(ServerState.LOOKING);</span>
<span class="fc" id="L826">                        }</span>
                    }
<span class="fc" id="L828">                    break;</span>
                case OBSERVING:
                    try {
<span class="fc" id="L831">                        LOG.info(&quot;OBSERVING&quot;);</span>
<span class="fc" id="L832">                        setObserver(makeObserver(logFactory));</span>
<span class="fc" id="L833">                        observer.observeLeader();</span>
<span class="pc" id="L834">                    } catch (Exception e) {</span>
<span class="nc" id="L835">                        LOG.warn(&quot;Unexpected exception&quot;,e );                        </span>
<span class="nc" id="L836">                    } finally {</span>
<span class="nc" id="L837">                        observer.shutdown();</span>
<span class="pc" id="L838">                        setObserver(null);</span>
<span class="pc" id="L839">                        setPeerState(ServerState.LOOKING);</span>
<span class="pc" id="L840">                    }</span>
<span class="fc" id="L841">                    break;</span>
                case FOLLOWING:
                    try {
<span class="fc" id="L844">                        LOG.info(&quot;FOLLOWING&quot;);</span>
<span class="fc" id="L845">                        setFollower(makeFollower(logFactory));</span>
<span class="fc" id="L846">                        follower.followLeader();</span>
<span class="pc" id="L847">                    } catch (Exception e) {</span>
<span class="nc" id="L848">                        LOG.warn(&quot;Unexpected exception&quot;,e);</span>
<span class="nc" id="L849">                    } finally {</span>
<span class="nc" id="L850">                        follower.shutdown();</span>
<span class="pc" id="L851">                        setFollower(null);</span>
<span class="pc bpc" id="L852" title="1 of 2 branches missed.">                        setPeerState(ServerState.LOOKING);</span>
<span class="pc" id="L853">                    }</span>
<span class="fc" id="L854">                    break;</span>
                case LEADING:
<span class="fc" id="L856">                    LOG.info(&quot;LEADING&quot;);</span>
                    try {
<span class="fc" id="L858">                        setLeader(makeLeader(logFactory));</span>
<span class="fc" id="L859">                        leader.lead();</span>
<span class="fc" id="L860">                        setLeader(null);</span>
<span class="fc" id="L861">                    } catch (Exception e) {</span>
<span class="fc" id="L862">                        LOG.warn(&quot;Unexpected exception&quot;,e);</span>
<span class="fc" id="L863">                    } finally {</span>
<span class="nc" id="L864">                        if (leader != null) {</span>
<span class="pc" id="L865">                            leader.shutdown(&quot;Forcing shutdown&quot;);</span>
<span class="pc" id="L866">                            setLeader(null);</span>
                        }
<span class="pc bpc" id="L868" title="3 of 4 branches missed.">                        setPeerState(ServerState.LOOKING);</span>
<span class="fc" id="L869">                    }</span>
<span class="fc" id="L870">                    break;</span>
                }
            }
<span class="fc" id="L873">        } finally {</span>
<span class="nc" id="L874">            LOG.warn(&quot;QuorumPeer main thread exited&quot;);</span>
            try {
<span class="pc" id="L876">                MBeanRegistry.getInstance().unregisterAll();</span>
<span class="nc" id="L877">            } catch (Exception e) {</span>
<span class="nc" id="L878">                LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="pc" id="L879">            }</span>
<span class="pc" id="L880">            jmxQuorumBean = null;</span>
<span class="pc" id="L881">            jmxLocalPeerBean = null;</span>
<span class="fc" id="L882">        }</span>
<span class="fc" id="L883">    }</span>

    public void shutdown() {
<span class="fc" id="L886">        running = false;</span>
<span class="fc bfc" id="L887" title="All 2 branches covered.">        if (leader != null) {</span>
<span class="fc" id="L888">            leader.shutdown(&quot;quorum Peer shutdown&quot;);</span>
        }
<span class="fc bfc" id="L890" title="All 2 branches covered.">        if (follower != null) {</span>
<span class="fc" id="L891">            follower.shutdown();</span>
        }
<span class="fc" id="L893">        cnxnFactory.shutdown();</span>
<span class="fc bfc" id="L894" title="All 2 branches covered.">        if(udpSocket != null) {</span>
<span class="fc" id="L895">            udpSocket.close();</span>
        }
        
<span class="fc bfc" id="L898" title="All 2 branches covered.">        if(getElectionAlg() != null){</span>
<span class="fc" id="L899">            this.interrupt();</span>
<span class="fc" id="L900">        	getElectionAlg().shutdown();</span>
        }
        try {
<span class="fc" id="L903">            zkDb.close();</span>
<span class="nc" id="L904">        } catch (IOException ie) {</span>
<span class="nc" id="L905">            LOG.warn(&quot;Error closing logs &quot;, ie);</span>
<span class="fc" id="L906">        }     </span>
<span class="fc" id="L907">    }</span>

    /**
     * A 'view' is a node's current opinion of the membership of the entire
     * ensemble.    
     */
    public Map&lt;Long,QuorumPeer.QuorumServer&gt; getView() {
<span class="fc" id="L914">        return Collections.unmodifiableMap(this.quorumPeers);</span>
    }
    
    /**
     * Observers are not contained in this view, only nodes with 
     * PeerType=PARTICIPANT.     
     */
    public Map&lt;Long,QuorumPeer.QuorumServer&gt; getVotingView() {
<span class="fc" id="L922">        Map&lt;Long,QuorumPeer.QuorumServer&gt; ret = </span>
            new HashMap&lt;Long, QuorumPeer.QuorumServer&gt;();
<span class="fc" id="L924">        Map&lt;Long,QuorumPeer.QuorumServer&gt; view = getView();</span>
<span class="fc bfc" id="L925" title="All 2 branches covered.">        for (QuorumServer server : view.values()) {            </span>
<span class="fc bfc" id="L926" title="All 2 branches covered.">            if (server.type == LearnerType.PARTICIPANT) {</span>
<span class="fc" id="L927">                ret.put(server.id, server);</span>
            }
<span class="fc" id="L929">        }        </span>
<span class="fc" id="L930">        return ret;</span>
    }
    
    /**
     * Returns only observers, no followers.
     */
    public Map&lt;Long,QuorumPeer.QuorumServer&gt; getObservingView() {
<span class="nc" id="L937">        Map&lt;Long,QuorumPeer.QuorumServer&gt; ret = </span>
            new HashMap&lt;Long, QuorumPeer.QuorumServer&gt;();
<span class="nc" id="L939">        Map&lt;Long,QuorumPeer.QuorumServer&gt; view = getView();</span>
<span class="nc bnc" id="L940" title="All 2 branches missed.">        for (QuorumServer server : view.values()) {            </span>
<span class="nc bnc" id="L941" title="All 2 branches missed.">            if (server.type == LearnerType.OBSERVER) {</span>
<span class="nc" id="L942">                ret.put(server.id, server);</span>
            }
<span class="nc" id="L944">        }        </span>
<span class="nc" id="L945">        return ret;</span>
    }
    
    /**
     * Check if a node is in the current view. With static membership, the
     * result of this check will never change; only when dynamic membership
     * is introduced will this be more useful.
     */
    public boolean viewContains(Long sid) {
<span class="fc" id="L954">        return this.quorumPeers.containsKey(sid);</span>
    }
    
    /**
     * Only used by QuorumStats at the moment
     */
    public String[] getQuorumPeers() {
<span class="nc" id="L961">        List&lt;String&gt; l = new ArrayList&lt;String&gt;();</span>
<span class="nc" id="L962">        synchronized (this) {</span>
<span class="nc bnc" id="L963" title="All 2 branches missed.">            if (leader != null) {</span>
<span class="nc bnc" id="L964" title="All 2 branches missed.">                for (LearnerHandler fh : leader.getLearners()) {</span>
<span class="nc bnc" id="L965" title="All 2 branches missed.">                    if (fh.getSocket() != null) {</span>
<span class="nc" id="L966">                        String s = fh.getSocket().getRemoteSocketAddress().toString();</span>
<span class="nc bnc" id="L967" title="All 2 branches missed.">                        if (leader.isLearnerSynced(fh))</span>
<span class="nc" id="L968">                            s += &quot;*&quot;;</span>
<span class="nc" id="L969">                        l.add(s);</span>
                    }
<span class="nc" id="L971">                }</span>
<span class="nc bnc" id="L972" title="All 2 branches missed.">            } else if (follower != null) {</span>
<span class="nc" id="L973">                l.add(follower.sock.getRemoteSocketAddress().toString());</span>
            }
<span class="nc" id="L975">        }</span>
<span class="nc" id="L976">        return l.toArray(new String[0]);</span>
    }

    public String getServerState() {
<span class="pc bpc" id="L980" title="2 of 5 branches missed.">        switch (getPeerState()) {</span>
        case LOOKING:
<span class="fc" id="L982">            return QuorumStats.Provider.LOOKING_STATE;</span>
        case LEADING:
<span class="fc" id="L984">            return QuorumStats.Provider.LEADING_STATE;</span>
        case FOLLOWING:
<span class="fc" id="L986">            return QuorumStats.Provider.FOLLOWING_STATE;</span>
        case OBSERVING:
<span class="nc" id="L988">            return QuorumStats.Provider.OBSERVING_STATE;</span>
        }
<span class="nc" id="L990">        return QuorumStats.Provider.UNKNOWN_STATE;</span>
    }


    /**
     * get the id of this quorum peer.
     */
    public long getMyid() {
<span class="fc" id="L998">        return myid;</span>
    }

    /**
     * set the id of this quorum peer.
     */
    public void setMyid(long myid) {
<span class="fc" id="L1005">        this.myid = myid;</span>
<span class="fc" id="L1006">    }</span>

    /**
     * Get the number of milliseconds of each tick
     */
    public int getTickTime() {
<span class="fc" id="L1012">        return tickTime;</span>
    }

    /**
     * Set the number of milliseconds of each tick
     */
    public void setTickTime(int tickTime) {
<span class="fc" id="L1019">        LOG.info(&quot;tickTime set to &quot; + tickTime);</span>
<span class="fc" id="L1020">        this.tickTime = tickTime;</span>
<span class="fc" id="L1021">    }</span>

    /** Maximum number of connections allowed from particular host (ip) */
    public int getMaxClientCnxnsPerHost() {
<span class="nc" id="L1025">        ServerCnxnFactory fac = getCnxnFactory();</span>
<span class="nc bnc" id="L1026" title="All 2 branches missed.">        if (fac == null) {</span>
<span class="nc" id="L1027">            return -1;</span>
        }
<span class="nc" id="L1029">        return fac.getMaxClientCnxnsPerHost();</span>
    }
    
    /** minimum session timeout in milliseconds */
    public int getMinSessionTimeout() {
<span class="nc bnc" id="L1034" title="All 2 branches missed.">        return minSessionTimeout == -1 ? tickTime * 2 : minSessionTimeout;</span>
    }

    /** minimum session timeout in milliseconds */
    public void setMinSessionTimeout(int min) {
<span class="fc" id="L1039">        LOG.info(&quot;minSessionTimeout set to &quot; + min);</span>
<span class="fc" id="L1040">        this.minSessionTimeout = min;</span>
<span class="fc" id="L1041">    }</span>

    /** maximum session timeout in milliseconds */
    public int getMaxSessionTimeout() {
<span class="nc bnc" id="L1045" title="All 2 branches missed.">        return maxSessionTimeout == -1 ? tickTime * 20 : maxSessionTimeout;</span>
    }

    /** minimum session timeout in milliseconds */
    public void setMaxSessionTimeout(int max) {
<span class="fc" id="L1050">        LOG.info(&quot;maxSessionTimeout set to &quot; + max);</span>
<span class="fc" id="L1051">        this.maxSessionTimeout = max;</span>
<span class="fc" id="L1052">    }</span>

    /**
     * Get the number of ticks that the initial synchronization phase can take
     */
    public int getInitLimit() {
<span class="fc" id="L1058">        return initLimit;</span>
    }

    /**
     * Set the number of ticks that the initial synchronization phase can take
     */
    public void setInitLimit(int initLimit) {
<span class="fc" id="L1065">        LOG.info(&quot;initLimit set to &quot; + initLimit);</span>
<span class="fc" id="L1066">        this.initLimit = initLimit;</span>
<span class="fc" id="L1067">    }</span>

    /**
     * Get the current tick
     */
    public int getTick() {
<span class="nc" id="L1073">        return tick;</span>
    }
    
    /**
     * Return QuorumVerifier object
     */
    
    public QuorumVerifier getQuorumVerifier(){
<span class="fc" id="L1081">        return quorumConfig;</span>
        
    }
    
    public void setQuorumVerifier(QuorumVerifier quorumConfig){
<span class="fc" id="L1086">       this.quorumConfig = quorumConfig;</span>
<span class="fc" id="L1087">    }</span>
    
    /**
     * Get an instance of LeaderElection
     */
        
    public Election getElectionAlg(){
<span class="fc" id="L1094">        return electionAlg;</span>
    }
        
    /**
     * Get the synclimit
     */
    public int getSyncLimit() {
<span class="fc" id="L1101">        return syncLimit;</span>
    }

    /**
     * Set the synclimit
     */
    public void setSyncLimit(int syncLimit) {
<span class="fc" id="L1108">        this.syncLimit = syncLimit;</span>
<span class="fc" id="L1109">    }</span>
    
    
    /**
     * The syncEnabled can also be set via a system property.
     */
    public static final String SYNC_ENABLED = &quot;zookeeper.observer.syncEnabled&quot;;
    
    /**
     * Return syncEnabled.
     * 
     * @return
     */
    public boolean getSyncEnabled() {
<span class="pc bpc" id="L1123" title="1 of 2 branches missed.">        if (System.getProperty(SYNC_ENABLED) != null) {</span>
<span class="nc" id="L1124">            LOG.info(SYNC_ENABLED + &quot;=&quot; + Boolean.getBoolean(SYNC_ENABLED));   </span>
<span class="nc" id="L1125">            return Boolean.getBoolean(SYNC_ENABLED);</span>
        } else {        
<span class="fc" id="L1127">            return syncEnabled;</span>
        }
    }
    
    /**
     * Set syncEnabled.
     * 
     * @param syncEnabled
     */
    public void setSyncEnabled(boolean syncEnabled) {
<span class="fc" id="L1137">        this.syncEnabled = syncEnabled;</span>
<span class="fc" id="L1138">    }</span>

    /**
     * Gets the election type
     */
    public int getElectionType() {
<span class="fc" id="L1144">        return electionType;</span>
    }

    /**
     * Sets the election type
     */
    public void setElectionType(int electionType) {
<span class="fc" id="L1151">        this.electionType = electionType;</span>
<span class="fc" id="L1152">    }</span>

    public boolean getQuorumListenOnAllIPs() {
<span class="fc" id="L1155">        return quorumListenOnAllIPs;</span>
    }

    public void setQuorumListenOnAllIPs(boolean quorumListenOnAllIPs) {
<span class="fc" id="L1159">        this.quorumListenOnAllIPs = quorumListenOnAllIPs;</span>
<span class="fc" id="L1160">    }</span>

    public ServerCnxnFactory getCnxnFactory() {
<span class="nc" id="L1163">        return cnxnFactory;</span>
    }

    public void setCnxnFactory(ServerCnxnFactory cnxnFactory) {
<span class="fc" id="L1167">        this.cnxnFactory = cnxnFactory;</span>
<span class="fc" id="L1168">    }</span>

    public void setQuorumPeers(Map&lt;Long,QuorumServer&gt; quorumPeers) {
<span class="fc" id="L1171">        this.quorumPeers = quorumPeers;</span>
<span class="fc" id="L1172">    }</span>

    public int getClientPort() {
<span class="fc" id="L1175">        return cnxnFactory.getLocalPort();</span>
    }

    public void setClientPortAddress(InetSocketAddress addr) {
<span class="fc" id="L1179">    }</span>
 
    public void setTxnFactory(FileTxnSnapLog factory) {
<span class="fc" id="L1182">        this.logFactory = factory;</span>
<span class="fc" id="L1183">    }</span>
    
    public FileTxnSnapLog getTxnFactory() {
<span class="fc" id="L1186">        return this.logFactory;</span>
    }

    /**
     * set zk database for this node
     * @param database
     */
    public void setZKDatabase(ZKDatabase database) {
<span class="fc" id="L1194">        this.zkDb = database;</span>
<span class="fc" id="L1195">    }</span>

    public void setRunning(boolean running) {
<span class="nc" id="L1198">        this.running = running;</span>
<span class="nc" id="L1199">    }</span>

    public boolean isRunning() {
<span class="fc" id="L1202">        return running;</span>
    }

    /**
     * get reference to QuorumCnxManager
     */
    public QuorumCnxManager getQuorumCnxManager() {
<span class="fc" id="L1209">        return qcm;</span>
    }
    private long readLongFromFile(String name) throws IOException {
<span class="fc" id="L1212">    	File file = new File(logFactory.getSnapDir(), name);</span>
<span class="fc" id="L1213">		BufferedReader br = new BufferedReader(new FileReader(file));</span>
<span class="fc" id="L1214">		String line = &quot;&quot;;</span>
		try {
<span class="fc" id="L1216">			line = br.readLine();</span>
<span class="fc" id="L1217">    		return Long.parseLong(line);</span>
<span class="nc" id="L1218">    	} catch(NumberFormatException e) {</span>
<span class="nc" id="L1219">    		throw new IOException(&quot;Found &quot; + line + &quot; in &quot; + file);</span>
    	} finally {
<span class="pc" id="L1221">    		br.close();</span>
    	}
    }

<span class="fc" id="L1225">    private long acceptedEpoch = -1;</span>
<span class="fc" id="L1226">    private long currentEpoch = -1;</span>

	public static final String CURRENT_EPOCH_FILENAME = &quot;currentEpoch&quot;;

	public static final String ACCEPTED_EPOCH_FILENAME = &quot;acceptedEpoch&quot;;

    public static final String UPDATING_EPOCH_FILENAME = &quot;updatingEpoch&quot;;

	/**
	 * Write a long value to disk atomically. Either succeeds or an exception
	 * is thrown.
	 * @param name file name to write the long to
	 * @param value the long value to write to the named file
	 * @throws IOException if the file cannot be written atomically
	 */
    private void writeLongToFile(String name, long value) throws IOException {
<span class="fc" id="L1242">        File file = new File(logFactory.getSnapDir(), name);</span>
<span class="fc" id="L1243">        AtomicFileOutputStream out = new AtomicFileOutputStream(file);</span>
<span class="fc" id="L1244">        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(out));</span>
<span class="fc" id="L1245">        boolean aborted = false;</span>
        try {
<span class="fc" id="L1247">            bw.write(Long.toString(value));</span>
<span class="fc" id="L1248">            bw.flush();</span>
            
<span class="fc" id="L1250">            out.flush();</span>
<span class="pc" id="L1251">        } catch (IOException e) {</span>
<span class="nc" id="L1252">            LOG.error(&quot;Failed to write new file &quot; + file, e);</span>
            // worst case here the tmp file/resources(fd) are not cleaned up
            //   and the caller will be notified (IOException)
<span class="nc" id="L1255">            aborted = true;</span>
<span class="nc" id="L1256">            out.abort();</span>
<span class="nc" id="L1257">            throw e;</span>
        } finally {
<span class="nc" id="L1259">            if (!aborted) {</span>
                // if the close operation (rename) fails we'll get notified.
                // worst case the tmp file may still exist
<span class="pc bnc" id="L1262" title="All 2 branches missed.">                out.close();</span>
            }
<span class="fc" id="L1264">        }</span>
<span class="pc bpc" id="L1265" title="1 of 2 branches missed.">    }</span>

    public long getCurrentEpoch() throws IOException {
<span class="fc bfc" id="L1268" title="All 2 branches covered.">		if (currentEpoch == -1) {</span>
<span class="fc" id="L1269">			currentEpoch = readLongFromFile(CURRENT_EPOCH_FILENAME);</span>
		}
<span class="fc" id="L1271">		return currentEpoch;</span>
	}
	
	public long getAcceptedEpoch() throws IOException {
<span class="fc bfc" id="L1275" title="All 2 branches covered.">		if (acceptedEpoch == -1) {</span>
<span class="fc" id="L1276">			acceptedEpoch = readLongFromFile(ACCEPTED_EPOCH_FILENAME);</span>
		}
<span class="fc" id="L1278">		return acceptedEpoch;</span>
	}
	
	public void setCurrentEpoch(long e) throws IOException {
<span class="fc" id="L1282">		currentEpoch = e;</span>
<span class="fc" id="L1283">		writeLongToFile(CURRENT_EPOCH_FILENAME, e);</span>
		
<span class="fc" id="L1285">	}</span>
	
	public void setAcceptedEpoch(long e) throws IOException {
<span class="fc" id="L1288">		acceptedEpoch = e;</span>
<span class="fc" id="L1289">		writeLongToFile(ACCEPTED_EPOCH_FILENAME, e);</span>
<span class="fc" id="L1290">	}</span>

    /**
     * Updates leader election info to avoid inconsistencies when
     * a new server tries to join the ensemble.
     * See ZOOKEEPER-1732 for more info.
     */
    protected void updateElectionVote(long newEpoch) {
<span class="fc" id="L1298">        Vote currentVote = getCurrentVote();</span>
<span class="fc" id="L1299">        setBCVote(currentVote);</span>
<span class="fc bfc" id="L1300" title="All 2 branches covered.">        if (currentVote != null) {</span>
<span class="fc" id="L1301">            setCurrentVote(new Vote(currentVote.getId(),</span>
<span class="fc" id="L1302">                currentVote.getZxid(),</span>
<span class="fc" id="L1303">                currentVote.getElectionEpoch(),</span>
                newEpoch,
<span class="fc" id="L1305">                currentVote.getState()));</span>
        }
<span class="fc" id="L1307">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>